import es
import popuplib 
import playerlib
import usermsg
import weaponlib
import votelib
import random
import gamethread
import sys, traceback
import psyco
import spe 
from spe.games import cstrike 
import effectlib
import vecmath 
import langlib
psyco.full()

NEAR_VALUE = 100

info = es.AddonInfo()
info.name = "Radiactive MoD"
info.version = "0.5 (alpha)"
info.author = "Buho"
info.url = "http://www.sohpro.zobyhost.com"
info.basename = "RMOD"
info.description = "A rpg mod for Counter Strike Source"

clase = 0
saveround = 0
text = langlib.Strings(es.getAddonPath("rmod") + "/strings.ini")
#Al cargarse el addon...
def load():
	#Traducciones
	#Hacer publica la version del addon
	es.set("RMOD_version", info.version)
	es.makepublic("RMOD_version")
	#Mirar si existe el keygroup rmod, donde almacenamos todos los valores de los usuarios
	exist_rmod = es.exists("keygroup", "rmod")
	#si existe...
	if exist_rmod == 1:
		#guardar los datos de los usuarios
		es.keygroupsave("rmod", "|rmod")
		#eliminar de la memoria los datos de los usuarios
		es.keygroupdelete("rmod")
	#cargar el keygroup rmod
	es.keygroupload("rmod", "|rmod")
	if not es.exists('saycommand', '/clase'):
		#comando para mostrar el menu de clase 
		es.regsaycmd("/clase", "rmod/cc") 
		#comando para mostrar el menu de ayuda
		es.regsaycmd("/ayuda", "rmod/help")
		#comando para mostrar la tienda 
		es.regsaycmd("/shop", "rmod/tienda") 
		#comando para ver la experiencia, nivel y rpts 
		es.regsaycmd("/iexp", "rmod/iclass") 
		#comando para ver el menu de informacion de cada clase, necesita argumentos 
		es.regsaycmd("/iclase", "rmod/classess") 
		#comando para ver el menu de informacion 
		es.regsaycmd("/ayuda", "rmod/help") 
		#comando para ver el menu de canjeamiento de RPts 
		es.regsaycmd("/skills", "rmod/sk") 
		#comando para accionar las habilidades
		es.regsaycmd("/habil", "rmod/habil") 
		#comando para ver el menu de misiones
		es.regsaycmd("/quest", "rmod/quests") 
		#comando para guardar datos
		es.regsaycmd("/save", "rmod/save") 
		es.regsaycmd("/resp", "rmod/respawn")
	
def is_near_player(player_a, player_b): 
    location_a = es.getplayerlocation(player_a) 
    location_b = es.getplayerlocation(player_b) 
    vector_a = vecmath.vector(location_a) 
    vector_b = vecmath.vector(location_b) 
    distance_between_players = (vector_a - vector_b).length() 
    return (distance_between_players <= NEAR_VALUE) 
	
def habil():
	userid = es.getcmduserid()
	steam = es.getplayersteamid(userid)
	cfgLang = playerlib.getPlayer(userid).lang
	clase = es.keygetvalue("rmod", steam, "clase")
	lvlsk = es.keygetvalue("rmod", steam, "lvl")
	rpts = int(es.keygetvalue("rmod", steam, "rpts"))
	arg = es.getargv(1)
	if arg == "1":
		if clase == "Ninja":
			if rpts >= 1500:
				rpts = rpts - 1500
				es.keysetvalue("rmod", steam, "rpts", rpts)
				ninja = playerlib.getPlayer(userid)
				ninja.setSpeed(1.7) 
				gamethread.delayed(3, ninja.setSpeed, (0.8))
			else:
				es.tell(userid, '#multi', text('otros 3', None, cfgLang))
		elif clase == "Piromano":
			lvl1 = int(es.keygetvalue("rmod", steam, "skill1"))
			if lvl1 == 0:
				es.tell(userid, '#multi', text('otros 4', None, cfgLang))
				es.tell(userid, '#multi', text('otros 5', None, cfgLang))
				es.keysetvalue("rmod", steam, "skill1", 1)
			else:
				es.tell(userid, '#multi', text('otros 6', None, cfgLang))
				es.keysetvalue("rmod", steam, "skill1", 0)
	
def player_move(event_var):
	userid = event_var['userid']
	steam = es.getplayersteamid(userid)
	clase = es.keygetvalue("rmod", steam, "clase")
	if clase == "Francotirador":
		playerlib.getPlayer(userid).setColor(60, 60, 255, 255)
		
def player_activate(event_var):
	userid = event_var['userid']
	if popuplib.exists("wlm"): 
		popuplib.delete("wlm")
	plang = playerlib.getPlayer(userid).lang 
	wlm = popuplib.easymenu('wlm', '_popup_choice', menu_wlm) 
	wlm.settitle(text("popup wlm 1", None, plang)) 
	wlm.addoption('1', text("popup wlm 2", None, plang)) 
	wlm.addoption('1', text("popup wlm 3", None, plang)) 
	wlm.addoption('1', text("popup wlm 4", None, plang)) 
	wlm.addoption('1', text("popup wlm 5", None, plang)) 
	wlm.addoption('1', text("popup wlm 6", None, plang)) 
	wlm.send(userid)
	steam = es.getplayersteamid(userid)
	if not es.exists("key", "rmod", steam):
		es.keycreate("rmod", steam)
		es.keysetvalue("rmod", steam, "xp", 0)
		es.keysetvalue("rmod", steam, "lvl", 1)
		es.keysetvalue("rmod", steam, "rpts", 300)
		es.keysetvalue("rmod", steam, "multip", 1)
		es.keysetvalue("rmod", steam, "clase", "none")
		es.keysetvalue("rmod", steam, "skill1", 0)
		es.keysetvalue("rmod", steam, "skill2", 0)
		es.keysetvalue("rmod", steam, "skill3", 0)
		es.keysetvalue("rmod", steam, "jump", 0)
		es.keysetvalue("rmod", steam, "resp", 0)
		
def menu_wlm(userid, choice, popupid):
	if popuplib.exists("clase"):
		popuplib.delete("clase")
	plang = playerlib.getPlayer(userid).lang 
	clase = popuplib.easymenu('clase', '_popup_choice', clases_menuselect)
	clase.settitle(text('popup class 1', None, plang))
	clase.addoption('Ninja', text('popup class 2', None, plang))
	clase.addoption('Francotirador', text('popup class 3', None, plang))
	clase.addoption('Guerrillero', text('popup class 4', None, plang))
	clase.addoption('Piromano', text('popup class 5', None, plang))
	clase.send(userid)
	
def clases_menuselect (userid, choice, popupid):
	cfgLang = playerlib.getPlayer(userid).lang
	steam = es.getplayersteamid(userid)
	es.keysetvalue("rmod", steam, "clase", choice)
	if choice == "Ninja":	
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 0.8)
		lvl = int(es.keygetvalue("rmod", steam, "lvl"))
		lvl = lvl * 2
		opa = 255 - lvl
		if lvl < 100:
			playerlib.getPlayer(userid).setColor(60, 255, 60, opa)
		else:
			playerlib.getPlayer(userid).setColor(60, 255, 60, 50)
		es.tell(userid, "#multi", text('otros 19', None, cfgLang))
	elif choice == "Francotirador":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 130)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1)
		playerlib.getPlayer(userid).setColor(60, 60, 255, 255) 
		es.tell(userid, "#multi", text('otros 20', None, cfgLang))
	elif choice == "Guerrillero":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 85)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.4)
		playerlib.getPlayer(userid).setColor(255, 60, 255, 255) 
		es.tell(userid, "#multi", text('otros 20', None, cfgLang))
	#si es un piromano...
	elif choice== "Piromano":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 125)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.2)
		playerlib.getPlayer(userid).setColor(255, 60, 60, 255) 
		es.tell(userid, "#multi", text('otros 21', None, cfgLang))

def shop(userid, choice, popupid):
	steam = es.getplayersteamid(userid)
	cfgLang = playerlib.getPlayer(userid).lang
	money = playerlib.getPlayer(userid).cash 
	rpts = int(es.keygetvalue("rmod", steam, "rpts"))
	if choice == "1":
		if money >= 8000:
			rpts = rpts + 300
			money = money - 8000
			es.keysetvalue("rmod", steam, "rpts", rpts)
			playerlib.getPlayer(userid).cash = money
			es.tell(userid, '#multi', text('otros 7', None, cfgLang))
		else:
			es.tell(userid, '#multi', text('otros 8', None, cfgLang))
	elif choice == "2":
		if money == 16000:
			rpts = rpts + 800
			money = 0
			es.keysetvalue("rmod", steam, "rpts", rpts)
			playerlib.getPlayer(userid).cash = money
			es.tell(userid, '#multi', text('otros 7', None, cfgLang))
		else:
			es.tell(userid, '#multi', text('otros 8', None, cfgLang))
			
def quest_choice(userid, choice, popupid):
	steam = es.getplayersteamid(userid)
	cfgLang = playerlib.getPlayer(userid).lang
	clase = es.keygetvalue("rmod", steam, "clase")
	if choice == "1":
		if clase == "Piromano":
			if popuplib.exists("piquests"): 
				popuplib.delete("piquests")
			piquests = popuplib.easymenu("piquests", "_popup_choice", quest_choice)
			piquests.settitle(text('popup piquests 1', None, cfgLang))
			piquests.addoption('pi1', text('popup piquests 2', None, cfgLang))
			piquests.addoption('pi2', text('popup piquests 3', None, cfgLang))
			piquests.send(userid)
		else:
			es.tell(userid, '#multi', text('otros 9', None, cfgLang))
	elif choice == "2":
		if clase == "Ninja":
			if popuplib.exists("niquests"): 
				popuplib.delete("niquests")
			niquests = popuplib.easymenu("niquests", "_popup_choice", quest_choice)
			niquests.settitle(text('popup piquests 1', None, cfgLang))
			niquests.addoption('ni1', text('popup niquests 1', None, cfgLang))
			niquests.addoption('ni2', text('popup niquests 2', None, cfgLang))
			niquests.send(userid)
		else:
			es.tell(userid, '#multi', text('otros 10', None, cfgLang))
	elif choice == "3":
		if clase == "Francotirador":
			if popuplib.exists("frquests"): 
				popuplib.delete("frquests")
			frquests = popuplib.easymenu("frquests", "_popup_choice", quest_choice)
			frquests.settitle(text('popup piquests 1', None, cfgLang))
			frquests.addoption('fr1', text('popup frquests 1', None, cfgLang))
			frquests.addoption('fr2', text('popup frquests 2', None, cfgLang))
			frquests.send(userid)
		else:
			es.tell(userid, '#multi', text('otros 11', None, cfgLang))
	elif choice == "4":
		if clase == "Guerrillero":
			if popuplib.exists("guquests"): 
				popuplib.delete("guquests")
			guquests = popuplib.easymenu("guquests", "_popup_choice", quest_choice)
			guquests.settitle(text('popup piquests 1', None, cfgLang))
			guquests.addoption('gu1', text('popup guquests', None, cfgLang))
			guquests.send(userid)
		else:
			es.tell(userid, '#multi', text('otros 12', None, cfgLang))
	elif choice == "5":
		if popuplib.exists("genquests"): 
			popuplib.delete("genquests")
		genquests = popuplib.easymenu("guquests", "_popup_choice", quest_choice)
		genquests.settitle(text('popup piquests 1', None, cfgLang))
		genquests.addoption('gen1', text('popup genquests 1', None, cfgLang))
		genquests.addoption('gen2', text('popup genquests 2', None, cfgLang))
		genquests.addoption('gen3', text('popup genquests 3', None, cfgLang))
		genquests.addoption('gen4', text('popup genquests 4', None, cfgLang))
		genquests.addoption('gen5', text('popup genquests 5', None, cfgLang))
		genquests.addoption('gen6', text('popup genquests 6', None, cfgLang))
		genquests.addoption('gen7', text('popup genquests 7', None, cfgLang))
		genquests.send(userid)

def skills(userid, choice, popupid):
	cfgLang = playerlib.getPlayer(userid).lang
	ssteam = es.getplayersteamid(userid)
	srpts = int(es.keygetvalue("rmod", ssteam, "rpts"))
	if choice == "2":
		if srpts >= 2000:
			srpts = srpts - 2000
			resp = int(es.keygetvalue("rmod", ssteam, "resp"))
			resp = resp + 1
			es.keysetvalue("rmod", ssteam, "resp", resp)
			es.keysetvalue("rmod", ssteam, "rpts", srpts)
			es.tell(userid, '#multi', text('otros 13', None, cfgLang))
		else:
			es.tell(userid, '#multi', text('otros 14', None, cfgLang))
	if choice == "1":
		if srpts >= 700:
			sjump = int(es.keygetvalue("rmod", ssteam, "jump"))
			if sjump == 20:
				es.tell(userid, '#multi', text('otros 15', None, cfgLang))
			else:
				srpts = srpts - 700
				es.keysetvalue("rmod", ssteam, "rpts", srpts)
				sjump = sjump + 1
				es.keysetvalue("rmod", ssteam, "jump", sjump)
				es.tell(userid, '#multi', text('otros 16', None, cfgLang))
				es.tell(userid, '#multi', text('otros 17', None, cfgLang))
		elif srpts < 700:
			es.tell(userid, '#multi', text('otros 18', None, cfgLang))

def classess():
	userid = es.getcmduserid()
	cfgLang = playerlib.getPlayer(userid).lang
	steam = es.getplayersteamid(userid)
	arg = es.getargv(1)
	if arg == "ninja":
		es.tell(userid, '#multi', text('info class 1', None, cfgLang))
		es.tell(userid, '#multi', text('info class 2', None, cfgLang))
	if arg == "francotirador" or arg == "sharpshooter":
		es.tell(userid, '#multi', text('info class 3', None, cfgLang))
		es.tell(userid, '#multi', text('info class 4', None, cfgLang))
	if arg == "guerrillero" or arg == "guerrilla":
		es.tell(userid, '#multi', text('info class 5', None, cfgLang))
	if arg == "piromano" or arg == "arsonist":
		es.tell(userid, '#multi', text('info class 6', None, cfgLang))
		es.tell(userid, '#multi', text('info class 7', None, cfgLang))

def player_spawn(ev):
	userid = ev['userid']
	cfgLang = playerlib.getPlayer(userid).lang
	steam = es.getplayersteamid(userid)
	clase = es.keygetvalue("rmod", steam, "clase")
	if clase == "Ninja":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 100)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 0.8)
		lvl = int(es.keygetvalue("rmod", steam, "lvl"))
		lvl = lvl * 2
		opa = 255 - lvl
		if lvl < 100:
			playerlib.getPlayer(userid).setColor(60, 255, 60, opa)
		else:
			playerlib.getPlayer(userid).setColor(60, 255, 60, 50)
		es.tell(userid, "#multi", text('otros 19', None, cfgLang))
	elif clase == "Francotirador":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 130)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1)
		playerlib.getPlayer(userid).setColor(60, 60, 255, 255) 
		es.tell(userid, "#multi", text('otros 20', None, cfgLang))
	elif clase == "Guerrillero":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 80)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.4)
		playerlib.getPlayer(userid).setColor(255, 60, 255, 255) 
		es.tell(userid, "#multi", text('otros 20', None, cfgLang))
	elif clase == "Piromano":
		es.setplayerprop(userid, 'CBasePlayer.m_iHealth', 125)
		es.setplayerprop(userid, 'CBasePlayer.localdata.m_flLaggedMovementValue', 1.2)
		playerlib.getPlayer(userid).setColor(255, 60, 60, 255) 
		es.tell(userid, "#multi", text('otros 21', None, cfgLang))
		
def quests():
	if popuplib.exists("quests"): 
		popuplib.delete("quests")
	userid = es.getcmduserid()
	plang = playerlib.getPlayer(userid).lang
	quests = popuplib.easymenu("quests", "_popup_choice", quest_choice)
	quests.settitle(text('popup quests 1', lang=plang))
	quests.addoption('1', text('popup quests 2', lang=plang))
	quests.addoption('2', text('popup quests 3', lang=plang))
	quests.addoption('3', text('popup quests 4', lang=plang))
	quests.addoption('4', text('popup quests 5', lang=plang))
	quests.addoption('5', text('popup quests 6', lang=plang))
	quests.send(userid)
	
def tienda():
	global shop
	if popuplib.exists("shop"): 
		popuplib.delete("shop")
	userid = es.getcmduserid()
	plang = playerlib.getPlayer(userid).lang
	shop = popuplib.easymenu("shop", "_popup_choice", shop)
	shop.settitle(text('popup shop 1', lang=plang))
	shop.addoption('1', text('popup shop 2', lang=plang))
	shop.addoption('2', text('popup shop 3', lang=plang))
	shop.send(userid)

def help():
	if popuplib.exists("help"): 
		popuplib.delete("help")
	userid = es.getcmduserid()
	plang = playerlib.getPlayer(userid).lang 
	help = popuplib.easymenu('help', '_popup_choice', clases_menuselect)
	help.settitle(text('popup help 1', lang=plang))
	help.addoption('1', text('popup help 2', lang=plang))
	help.addoption('1', text('popup help 3', lang=plang))
	help.addoption('1', text('popup help 4', lang=plang))
	help.addoption('1', text('popup help 5', lang=plang))
	help.addoption('1', text('popup help 6', lang=plang))
	help.addoption('1', text('popup help 7', lang=plang))
	help.send(userid)
	
def sk():
	global skills
	if popuplib.exists("skills"): 
		popuplib.delete("skills")
	userid = es.getcmduserid()
	plang = playerlib.getPlayer(userid).lang 
	skills = popuplib.easymenu("skills", "_popup_choice", skills)
	skills.settitle(text('popup skills 1', lang=plang))
	skills.addoption('1', text('popup skills 2', lang=plang))
	skills.addoption('2', text('popup skills 3', lang=plang))
	skills.send(userid)
	
def save():
	es.keygroupsave("rmod", "|rmod")

def iclass():
	userid = es.getcmduserid()
	cfgLang = playerlib.getPlayer(userid).lang 
	steam = es.getplayersteamid(userid)
	tokens = {}
	tokens['ilvl'] = es.keygetvalue("rmod", steam, "lvl")
	tokens['ijump'] = es.keygetvalue("rmod", steam, "jump")
	tokens['iclase'] = es.keygetvalue("rmod", steam, "clase")
	tokens['rr'] = es.keygetvalue("rmod", steam, "resp")
	clase = es.keygetvalue("rmod", steam, "clase")
	tokens['irpts'] = es.keygetvalue("rmod", steam, "rpts")
	tokens['ixp'] = es.keygetvalue("rmod", steam, "xp")
	es.tell(userid, '#multi', text('stats 1', tokens, cfgLang))
	es.tell(userid, '#multi', text('stats 2', tokens, cfgLang))
	es.tell(userid, '#multi', text('stats 3', tokens, cfgLang))	
	es.tell(userid, '#multi', text('stats 4', tokens, cfgLang))
	es.tell(userid, '#multi', text('stats 9', tokens, cfgLang))
	if clase == "Francotirador":
		es.tell(userid, '#multi', text('stats 5', None, cfgLang))
	elif clase == "Ninja":
		es.tell(userid, '#multi', text('stats 6', None, cfgLang))
	elif clase == "Piromano":
		es.tell(userid, '#multi', text('stats 7', None, cfgLang))
	elif clase == "Guerrillero":
		es.tell(userid, '#multi', text('stats 8', None, cfgLang))
	

		
def player_jump(event_var):
	userid = event_var['userid']
	jsteam = es.getplayersteamid(userid)
	jrpts = int(es.keygetvalue("rmod", jsteam, "rpts"))
	jjump = int(es.keygetvalue("rmod", jsteam, "jump"))
	if jjump > 0:
		if jrpts >= 25:
			jumpy = jjump * 5
			jumpo = jjump * 10
			victim = playerlib.getPlayer(userid)
			victim.push(jumpo, jumpy, 1)
			jrpts = jrpts - 25
			es.keysetvalue("rmod", jsteam, "rpts", jrpts)

def player_death(event_var):
	if event_var['weapon'] != "world":
		if event_var['es_userteam'] != event_var['es_attackerteam']:
			userid = event_var["attacker"]
			cfgLang = playerlib.getPlayer(userid).lang
			steam = es.getplayersteamid(userid)
			useridus = event_var['userid']
			pLang = playerlib.getPlayer(useridus).lang
			steamus = es.getplayersteamid(useridus)
			pclase = es.keygetvalue("rmod", steam, "clase")
			dlvl = int(es.keygetvalue("rmod", steam, "lvl"))
			plvl = int(es.keygetvalue("rmod", steamus, "lvl"))
			pxp = int(es.keygetvalue("rmod", steam, "xp"))
			rpoints = int(es.keygetvalue("rmod", steam, "rpts"))
			pmultip = int(es.keygetvalue("rmod", steam, "multip"))
			hs = int(event_var["headshot"])
			pmultip = pmultip + 1
			xpneed = plvl * 300
			xpgain = 350 * pmultip
			lvldif = plvl - dlvl
			rptsgain = 0
			if lvldif > 5:
				rptsgain = 50 * lvldif
				rpoints = rpoints + rptsgain
				xpbonus = lvldif * 25
			if hs == 1:
				rptsgain = rptsgain + 75
				rpoints = rpoints + 75
				xpgain = xpgain + 100
			pxp = pxp + xpgain
			ulvl = 0
			while pxp >= xpneed:
				pxp = pxp - xpneed
				ulvl = ulvl + 1
				dlvl = dlvl + 1
			tokens = {}
			tokens['ulvl'] = ulvl
			tokens['rptsgain'] = rptsgain
			es.tell(userid, '#multi', text('levelup 1', tokens, cfgLang))
			es.tell(userid, '#multi', text('levelup 2', tokens, cfgLang))
			es.tell(userid, '#multi', text('levelup 3', None, cfgLang))
			es.tell(useridus, '#multi', text('levelup 4', None, pLang))
			es.keysetvalue("rmod", steam, "xp", pxp)
			es.keysetvalue("rmod", steam, "rpts", rpoints)
			es.keysetvalue("rmod", steam, "lvl", plvl)
			es.keysetvalue("rmod", steam, "multip", pmultip)
			resp = int(es.keygetvalue("rmod", steamus, "resp"))
			if resp == 1:
				cstrike.respawn(useridus) 
				resp = resp - 1
				es.keysetvalue("rmod", steamus, "resp", resp)
				es.tell(useridus, '#multi', text('levelup 5', None, pLang))

def bomb_exploded(event_var):
	PlayerList = es.getUseridList()
        for Player in PlayerList:
			if playerlib.getPlayer(Player).teamid == 2:
				rpts = 0
				xp = 0
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				es.tell(Player, '#multi', text('misc 1', None, cfgLang))
				es.tell(Player, '#multi', text('misc 2', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts + 250
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
				xp = int(es.keygetvalue("rmod", pplayer.steamid, "xp"))
				xp = xp + 250
				es.keysetvalue("rmod", pplayer.steamid, "xp", xp)
			elif playerlib.getPlayer(Player).teamid == 3:
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				rpts = 0
				es.tell(Player, '#multi', text('misc 3', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts - 50
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
		
def bomb_defused(event_var):
	PlayerList = es.getUseridList()
        for Player in PlayerList:
			if playerlib.getPlayer(Player).teamid == 3:
				rpts = 0
				xp = 0
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				es.tell(Player, '#multi', text('misc 4', None, cfgLang))
				es.tell(Player, '#multi', text('misc 5', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts + 150
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
				xp = int(es.keygetvalue("rmod", pplayer.steamid, "xp"))
				xp = xp + 150
				es.keysetvalue("rmod", pplayer.steamid, "xp", xp)
			elif playerlib.getPlayer(Player).teamid == 2:
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				rpts = 0
				es.tell(Player, '#multi', text('misc 6', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts - 50
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
		
def hostage_rescued(event_var):
	PlayerList = es.getUseridList()
        for Player in PlayerList:
			if playerlib.getPlayer(Player).teamid == 3:
				rpts = 0
				xp = 0
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				es.tell(Player, '#multi', text('misc 7', None, cfgLang))
				es.tell(Player, '#multi', text('misc 8', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts + 50
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
				xp = int(es.keygetvalue("rmod", pplayer.steamid, "xp"))
				xp = xp + 50
				es.keysetvalue("rmod", pplayer.steamid, "xp", xp)
			elif playerlib.getPlayer(Player).teamid == 2:
				pplayer = playerlib.getPlayer(Player)
				cfgLang = pplayer.lang
				rpts = 0
				es.tell(Player, '#multi', text('misc 9', None, cfgLang))
				rpts = int(es.keygetvalue("rmod", pplayer.steamid, "rpts"))
				rpts = rpts - 50
				es.keysetvalue("rmod", pplayer.steamid, "rpts", rpts)
	
def pre_falldamage(ev=None):
	if ev is None: ev = getVars()
	userid = ev['userid']
	dmg = ev['damage']
	health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
	es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health + dmg)

def pre_hurt(ev):
	dmg = ev['dmg_health']
	userid = ev['userid']
	attacker = ev['attacker']
	weapon = ev['weapon']
	steamat = es.getplayersteamid(attacker)
	steam = es.getplayersteamid(userid)
	clase = es.keygetvalue("rmod", steam, "clase")
	claseat = es.keygetvalue("rmod", steamat, "clase")
	if clase == "Guerrillero":
		rpts = int(es.keygetvalue("rmod", steam, "rpts"))
		if rpts >= 25:
			ran = random.randint(1, 10)
			if ran == 5:
				health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
				es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health + dmg)
				rpts = rpts - 25
				es.keysetvalue("rmod", steam, "rpts", rpts)
	if claseat == "Piromano":
		if weapon == 'm249':
			dmg = ev['dmg_health']
			dmg = dmg / 2
			health = int(es.getplayerprop(userid, 'CBasePlayer.m_iHealth'))
			es.setplayerprop(userid, 'CBasePlayer.m_iHealth', health + dmg)
			
def player_hurt(event_var): 
	check_arma(int(event_var['attacker']), event_var['weapon'])
	userid = event_var['userid'] 
	attacker = event_var['attacker']
	steamat = es.getplayersteamid(attacker)
	steamus = es.getplayersteamid(userid)
	claseat = es.keygetvalue("rmod", steamat, "clase")
	claseus = es.keygetvalue("rmod", steamus, "clase")
	if claseat == "Piromano":
		weapon = event_var['weapon']
		if weapon == "m249": 
			if not event_var['es_userdead'] == "1": 
				ran = random.randint(1, 10)
				if ran == 5:
					victim = playerlib.getPlayer(userid) 
					victim.burn() 
					burned = victim
					gamethread.delayed(4, burned.extinguish)
		elif weapon == "knife":
			sklvl = int(es.keygetvalue("rmod", steamat, "skill1"))
			if sklvl == 1:
				rpts = int(es.keygetvalue("rmod", steam, "rpts"))
				if rpts >= 1500:
					rpts = rpts - 1500
					es.keysetvalue("rmod", steam, "rpts", rpts)
					victim = playerlib.getPlayer(userid) 
					victim.burn() 
					burned = victim
					gamethread.delayed(4, burned.extinguish)
					
	if claseus == "Guerrillero":
		rpts = int(es.keygetvalue("rmod", steamus, "rpts"))
		if rpts >= 25:
			ran = random.randint(1, 10)
			if ran == 5:
				dmg = ev['dmg_health']
				lvl = es.keygetvalue("rmod", steamus, "lvl")
				dmg = dmg / 4
				rpts = rpts - 25
				es.keysetvalue("rmod", steamus, "rpts", rpts)
				health = int(es.getplayerprop(attacker, 'CBasePlayer.m_iHealth'))
				es.setplayerprop(attacker, 'CBasePlayer.m_iHealth', health - dmg)
	
	 
def weapon_fire(event_var):
	check_arma(int(event_var['attacker']), event_var['es_userweapon'])
	steam = es.getplayersteamid(event_var['userid'])
	clase = es.keygetvalue("rmod", steam, "clase")
	userid = event_var['userid']
	if clase == "Francotirador":
		playerlib.getPlayer(userid).setColor(60, 60, 255, 255)
	
def item_pickup(event_var):
	check_arma(int(event_var['userid']), event_var['item'])

def hegrenade_detonate(event_var):
	userid = int(event_var['userid'])
	steam = es.getplayersteamid(userid)
	Class = es.keygetvalue("rmod", steam, "clase")
	if Class == "Piromano":
		es.server.queuecmd('es_xgive %s %s'%(event_var['userid'], 'weapon_hegrenade'))

def check_arma(userid, arma):
	cfgLang = playerlib.getPlayer(userid).lang
	steam = es.getplayersteamid(userid)
	Class = es.keygetvalue("rmod", steam, "clase")
	if Class == "Ninja":
		if not arma in ['glock', 'usp', 'p228', 'elite', 'deagle', 'fiveseven', 'knife', 'tmp', 'mp5navy', 'ump45', 'p90', 'hegrenade', 'c4', 'flashbang', 'smokegrenade']:
			for index in es.createentitylist('weapon_' + arma):
				if es.getplayerhandle(userid) == es.getindexprop(index, "CBaseEntity.m_hOwnerEntity"):
					es.cexec(userid, 'lastinv')
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(userid, '#multi', text('otros 22', None, cfgLang))
					break
	elif Class == "Piromano":
		if not arma in ['glock', 'usp', 'p228', 'elite', 'deagle', 'fiveseven', 'knife', 'm249', 'hegrenade', 'c4', 'flashbang', 'smokegrenade']:
			for index in es.createentitylist('weapon_' + arma):
				if es.getplayerhandle(userid) == es.getindexprop(index, "CBaseEntity.m_hOwnerEntity"):
					es.cexec(userid, 'lastinv')
					es.server.queuecmd('es_xremove %s'%index)
					es.tell(userid, '#multi', text('otros 22', None, cfgLang))
					break

def cc():
	if popuplib.exists("clase"):
		popuplib.delete("clase")
	userid = es.getcmduserid()
	plang = playerlib.getPlayer(userid).lang 
	clase = popuplib.easymenu('clase', '_popup_choice', clases_menuselect)
	clase.settitle(text('popup class 1', lang=plang))
	clase.addoption('Ninja', text('popup class 2', lang=plang))
	clase.addoption('Francotirador', text('popup class 3', lang=plang))
	clase.addoption('Guerrillero', text('popup class 4', lang=plang))
	clase.addoption('Piromano', text('popup class 5', lang=plang))
	clase.send(userid)

def round_end(ev):
	global saveround
	saveround = saveround + 1
	if saveround == 4:
		es.keygroupsave("rmod", "|rmod")
		saveround = 0
		
def game_end(ev):
	es.keygroupsave("rmod", "|rmod")
	
def unload():
	es.keygroupsave("rmod", "|rmod")
	es.unregsaycmd("/clase")
	es.unregsaycmd("/ayuda")
	es.unregsaycmd("/skills")
	es.unregsaycmd("/shop")
	es.unregsaycmd("/iexp")
	es.unregsaycmd("/iclase")
	es.unregsaycmd("/habil")
	es.unregsaycmd("/save")
	es.unregsaycmd("/quest") 
	
#
#DEBUGGING
# 

def except_hook(type, value, tb):
   error_list = traceback.format_exception(type, value, tb)
   
   for message in error_list:
      es.log("[Exception] " + message.strip())
 
sys.excepthook = except_hook